package com.sd.app.did;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.webkit.WebView;
import android.webkit.WebChromeClient;
import android.util.Log;

import com.sd.app.did.fetcher.json.*;

public class VoteCastingActivity extends Activity
{
	WebView webView;
	private Handler handler;
	private static final String TAG = "VoteCastingActivity";
	private static final String HTML_ROOT = "file:///android_asset/www/";
	private static final String JAVASCRIPT = "javascript:";
	private static final String BRC = "()";
	private static final String BRC_OPEN = "(";
	private static final String BRC_CLOSE = ")";
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
	webView = new WebView(this);
	webView.getSettings().setJavaScriptEnabled(true);
	webView.addJavascriptInterface(this,"voteApp");
	webView.setWebChromeClient(new WebChromeClient(){
		public void onConsoleMessage(String msg, int lineNumb,String srcId){
			Log.v(TAG,msg + "from line "+lineNumb + " of " + srcId);
		}
	});
        setContentView(webView);
	handler = new Handler();
	loadPage("index.html");

    }
    
    private void loadPage(String homePage){
	    final String url = HTML_ROOT+homePage;
	    loadUrl(url);
    }

    private void loadUrl(final String url){
	    handler.post(new Runnable(){
		    public void run(){
			    webView.loadUrl(url);
		    }
	    });
    }

    public void showContestants(String callbackFunc) {
	    final String contestants = new ContestantsFetcher().fetchContestants();
	    String temp = JAVASCRIPT + callbackFunc+ BRC_OPEN+ contestants + BRC_CLOSE;
	    Log.v(TAG,temp);
	    final String callbackFuncString = JAVASCRIPT + callbackFunc + BRC_OPEN +contestants + BRC_CLOSE;
	    loadUrl(callbackFuncString);
    }

}
